3 # Copyright (c) 2005 Junio C Hamano
4 # Copyright (c) 2006 Yann Dirson - tuning for stgit
7 # Keep the original TERM for say_color
10 # For repeatability, reset the environment to known value.
16 export LANG LC_ALL PAGER TERM TZ
23 unset COMMIT_AUTHOR_EMAIL
24 unset COMMIT_AUTHOR_NAME
26 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
28 GIT_AUTHOR_EMAIL=author@example.com
29 GIT_AUTHOR_NAME='A U Thor'
30 unset GIT_COMMITTER_DATE
31 GIT_COMMITTER_EMAIL=committer@example.com
32 GIT_COMMITTER_NAME='C O Mitter'
36 unset GIT_EXTERNAL_DIFF
38 unset GIT_OBJECT_DIRECTORY
39 unset SHA1_FILE_DIRECTORIES
40 unset SHA1_FILE_DIRECTORY
42 export GIT_MERGE_VERBOSITY
43 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
44 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
46 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
48 # Protect ourselves from common misconfiguration to export
49 # CDPATH into the environment
52 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
54 echo "* warning: Some tests will not work if GIT_TRACE" \
55 "is set as to trace on STDERR ! *"
56 echo "* warning: Please set GIT_TRACE to something" \
57 "other than 1, 2 or true ! *"
61 # Each test should start with something like this, after copyright notices:
63 # test_description='Description of this test...
64 # This test checks if command xyzzy does the right thing...
67 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
68 TERM=$ORIGINAL_TERM &&
71 tput bold >/dev/null 2>&1 &&
72 tput setaf 1 >/dev/null 2>&1 &&
73 tput sgr0 >/dev/null 2>&1
80 -d|--d|--de|--deb|--debu|--debug)
82 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
84 -h|--h|--he|--hel|--help)
86 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
87 export STGIT_DEBUG_LEVEL="-1"
89 -q|--q|--qu|--qui|--quie|--quiet)
98 if test -n "$color"; then
104 error) tput bold; tput setaf 1;; # bold red
105 skip) tput bold; tput setaf 2;; # bold green
106 pass) tput setaf 2;; # green
107 info) tput setaf 3;; # brown
108 *) test -n "$quiet" && return;;
117 test -z "$1" && test -n "$quiet" && return
124 say_color error "error: $*"
133 test "${test_description}" != "" ||
134 error "Test script did not set test_description."
136 if test "$help" = "t"
138 echo "$test_description"
143 if test "$verbose" = "t"
147 exec 4>/dev/null 3>/dev/null
156 echo >&5 "FATAL: Unexpected exit with code $?"
163 if test -z "${test_tick+set}"
167 test_tick=$(($test_tick + 60))
169 GIT_COMMITTER_DATE="$test_tick -0700"
170 GIT_AUTHOR_DATE="$test_tick -0700"
171 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
174 # You are not expected to call test_ok_ and test_failure_ directly, use
175 # the text_expect_* functions instead.
178 test_count=$(expr "$test_count" + 1)
179 say_color "" " ok $test_count: $@"
183 test_count=$(expr "$test_count" + 1)
184 test_failure=$(expr "$test_failure" + 1);
185 say_color error "FAIL $test_count: $1"
187 echo "$@" | sed -e 's/^/ /'
188 test "$immediate" = "" || { trap - exit; exit 1; }
191 test_known_broken_ok_ () {
192 test_count=$(expr "$test_count" + 1)
193 test_fixed=$(($test_fixed+1))
194 say_color "" " FIXED $test_count: $@"
197 test_known_broken_failure_ () {
198 test_count=$(expr "$test_count" + 1)
199 test_broken=$(($test_broken+1))
200 say_color skip " still broken $test_count: $@"
204 test "$debug" = "" || eval "$1"
214 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
215 this_test="$this_test.$(expr "$test_count" + 1)"
217 for skp in $GIT_SKIP_TESTS
226 say_color skip >&3 "skipping test: $@"
227 test_count=$(expr "$test_count" + 1)
228 say_color skip "skip $test_count: $1"
237 test_expect_failure () {
239 error "bug in the test script: not 2 parameters to test-expect-failure"
242 say >&3 "checking known breakage: $2"
244 if [ "$?" = 0 -a "$eval_ret" = 0 ]
246 test_known_broken_ok_ "$1"
248 test_known_broken_failure_ "$1"
254 test_expect_success () {
256 error "bug in the test script: not 2 parameters to test-expect-success"
259 say >&3 "expecting success: $2"
261 if [ "$?" = 0 -a "$eval_ret" = 0 ]
271 test_expect_code () {
273 error "bug in the test script: not 3 parameters to test-expect-code"
276 say >&3 "expecting exit code $1: $3"
278 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
288 # When running an StGit command that should exit with an error, use
289 # these instead of testing for any non-zero exit code with !.
294 test $? -eq $expected
296 general_error () { exit_code 1 "$@" ; }
297 command_error () { exit_code 2 "$@" ; }
298 conflict () { exit_code 3 "$@" ; }
300 # Old-infrastructure commands don't exit with the proper value on
301 # conflicts. But we don't want half the tests to fail because of that,
302 # so use this instead of "conflict" for them.
303 conflict_old () { command_error "$@" ; }
305 # Same thing, but for other commands that StGit where we just want to
306 # make sure that they fail instead of crashing.
309 test $? -gt 0 -a $? -le 129
312 # test_cmp is a helper function to compare actual and expected output.
313 # You can use it like:
315 # test_expect_success 'foo works' '
316 # echo expected >expected &&
318 # test_cmp expected actual
321 # This could be written as either "cmp" or "diff -u", but:
322 # - cmp's output is not nearly as easy to read as diff -u
323 # - not all diff versions understand "-u"
329 # Most tests can use the created repository, but some may need to create more.
330 # Usage: test_create_repo <directory>
331 test_create_repo () {
333 error "bug in the test script: not 1 parameter to test-create-repo"
337 cd "$repo" || error "Cannot setup test environment"
338 git init >/dev/null 2>&1 || error "cannot run git init"
339 echo "empty start" | \
340 git commit-tree $(git write-tree) >.git/refs/heads/master 2>&4 || \
341 error "cannot run git commit"
342 mv .git/hooks .git/hooks-disabled
349 if test "$test_fixed" != 0
351 say_color pass "fixed $test_fixed known breakage(s)"
353 if test "$test_broken" != 0
355 say_color error "still have $test_broken known breakage(s)"
356 msg="remaining $(($test_count-$test_broken)) test(s)"
358 msg="$test_count test(s)"
360 case "$test_failure" in
363 # cd .. && rm -fr trash
364 # but that means we forbid any tests that use their own
365 # subdirectory from calling test_done without coming back
366 # to where they started from.
367 # The Makefile provided will clean this test area so
368 # we will leave things as they are.
370 say_color pass "passed all $msg"
374 say_color error "failed $test_failure among $msg"
380 # Test the binaries we have just built. The tests are kept in
381 # t/ subdirectory and are run in trash subdirectory.
384 GIT_CONFIG=.git/config
385 export PATH HOME GIT_CONFIG
391 echo >&5 "FATAL: Cannot prepare test area"
395 test_create_repo $test
398 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
399 for skp in $GIT_SKIP_TESTS
402 for skp in $GIT_SKIP_TESTS
411 say_color skip >&3 "skipping test $this_test altogether"
412 say_color skip "skip all tests in $this_test"